
Redmine - Defect #23189

Spent time by filter, offset by one day

2016-06-28 21:50 - Mentel Inc

Status: New Start date:  

Priority: High Due date:  

Assignee:  % Done: 0%

Category: Time tracking Estimated time: 0.00 hour

Target version:    

Resolution:  Affected version: 3.3.0

Description

We just upgrade to 3.3.0.stable.

If you log time today (June28) and then go in spent time, filter by today, the logged time isn't showing up. If you do yesterday, it

shows up with the today's date (June28).

Same issue in the project time logs.

However, if you select All, it works.

I tried to see if someone else had reported it, I couldn't find it, if it's the case I'm sorry in advance.

Related issues:

Related to Redmine - Patch #22320: Respect user's timezone when comparing / p... Closed

Related to Redmine - Defect #16482: Wrong search query for timelog, when time... New

Related to Redmine - Defect #33941: Do not use timezone unaware methods New

Has duplicate Redmine - Defect #24547: Spent Time Date Filter Off by 1 Day Closed

History

#1 - 2016-06-29 10:52 - Manuel Reinhardt

Same problem here, also on 3.3.0.stable. Workaround: I get correct results if I set the time zone in my account to the one used on the server.

#2 - 2016-06-29 13:55 - Mentel Inc

Manuel Reinhardt wrote:

Same problem here, also on 3.3.0.stable. Workaround: I get correct results if I set the time zone in my account to the one used on the server.

 I confirm, this turn around works perfectly.

Thanks Manu

#3 - 2016-06-29 18:15 - Jean-Philippe Lang

This is related to #22320. Date filters now take care of timezones.

Workaround: I get correct results if I set the time zone in my account to the one used on the server.

 Did you get incorrect results when leaving your timezone blank in your Redmine account?

#4 - 2016-06-29 18:16 - Jean-Philippe Lang

- Related to Patch #22320: Respect user's timezone when comparing / parsing Dates added

#5 - 2016-10-28 14:42 - Lucas Nogueira

hello,

I am also this problem .. Anyone know any way to fix?

Thanks!
#6 - 2016-12-11 01:49 - Go MAEDA

- Has duplicate Defect #24547: Spent Time Date Filter Off by 1 Day added

#7 - 2017-03-15 18:42 - Jamila Khan

I put my documentation in #16482-7, we are having this issue as well.

Is there more documentation that is needed that would help figure out the cause?

thanks,

#8 - 2017-04-14 05:34 - Toshi MARUYAMA

- Related to Defect #16482: Wrong search query for timelog, when timezone not UTC added

#9 - 2017-04-17 05:02 - Andrey Krot

- File 2017-04-17_10h00_03.jpg added

+

The same issue in tasks filter.

Control reports work incorrect.

#10 - 2018-03-05 05:15 - Phlip Plumlee

We have this bug, with version 3.4.2.stable.

On our server, with the UTC timezone, the Query system generates SQL that seems to compare a date by time adjusted by the timezone in my

preferences (PST): time_entries.spent_on >= '2018-01-09 07:59:59.999999' AND time_entries.spent_on <= '2018-01-10 07:59:59.999999'. I'm trying

for January 9th, there, and MySQL presumably converts a date of '2018-01-09' to a datetime of "midnight".

On my notebook, set to PST, the query is correct: time_entries.spent_on > '2018-01-14 23:59:59.999999' AND time_entries.spent_on <= '2018-01-15

23:59:59.999999'. I get the records I'm looking for, on '2018-01-15'.

When I erase my timezone from my Preferences on the server, the problem goes away.

I could fix this myself, as soon as I figure out where in the Query system that line gets generated...

#11 - 2018-03-29 18:12 - Steve Karrmann

- File 20180329_use_local_time_in_date_query.patch added

We encountered this issue as well. Date filters were returning results off by one day, but only for users with a time zone specified in their account

settings.

Our solution was to disable the time zone handling in class app/models/query.rb function date_for_user_time_zone - see attached patch.

With this change, all date filters return the correct dates, even for users with a time zone specified.

#12 - 2021-04-06 23:03 - Kevin Porras

Hi,

I'm having the same issue. The provided patch will make it work but, is this the right way to go? Is there a way we could help to make this fix

permanent into Redmine? (I'm sorry, I'm new to this issue queue)

#13 - 2022-01-16 10:30 - Go MAEDA

- Related to Defect #33941: Do not use timezone unaware methods added
